<template>
<div>

   <a-breadcrumb style="margin-left:10px;margin-top:5px;font-weight:bold;">

    <a-breadcrumb-item  @click="toPage()">
      <home-outlined />
      <span>评估规则</span>
    </a-breadcrumb-item>
    <a-breadcrumb-item>设置规则【{{rulename}}】</a-breadcrumb-item>
  </a-breadcrumb>

<!--
    <a-row :gutter="24">
    <a-col :span="24">
    <p style="margin-left:10px;margin-top:20px;font-weight:bold;">设置规则&nbsp;-&nbsp;{{rulename}}</p>
    </a-col>
    </a-row> -->
  </div>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
          <a-button type="primary" @click="batchHandleDelete" preIcon="ant-design:delete-outlined"> 删除</a-button>
          <a-button type="primary" @click="batchHandCopy" preIcon="ant-design:plus-outlined"> 复制</a-button>
          
          <!--
          <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
         -->
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <RateDomainModal @register="registerModal" @success="handleSuccess"></RateDomainModal>
    <RateDomainModalCopy @register="registerModalCopy" @success="handleSuccess"></RateDomainModalCopy>
  </div>
</template>

<script lang="ts" name="rate-rateDomain" setup>
  import {onMounted, ref, computed, unref,toRaw,inject} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import RateDomainModal from './components/RateDomainModal.vue'
  import RateDomainModalCopy from './components/RateDomainModalCopy.vue'
  import {columns, searchFormSchema} from './RateDomain.data';
  import {list, deleteOne, batchDelete, getImportUrl,getExportUrl} from './RateDomain.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import { useRoute } from 'vue-router';
  import { useRouter } from 'vue-router';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { HomeOutlined, UserOutlined } from '@ant-design/icons-vue';
  import { useTabs } from '/@/hooks/web/useTabs';
  const { closeCurrent, refreshPage, setTitle } = useTabs();
  const { createMessage } = useMessage();
  const route = useRoute();
  const router = useRouter();
  let rule_id = ref('');
  const rulename = ref('');
  const checkedKeys = ref<Array<string | number>>([]);
  let domain_ids = ref('');
  //注册model
  const [registerModal, {openModal}] = useModal();
  const [registerModalCopy, { openModal: openModalCopy}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '领域',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
          defSort :{
             column: 'valindex',
             order: 'asc',

          },
           actionColumn: {
               width: 120,
               fixed:'right'
            },
      },
       exportConfig: {
            name:"领域",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext


   onMounted(() => {
    rule_id = toRaw(route.query).id;
    rulename.value = toRaw(route.query).rulename;
    //console.log('rule_id---------->: ', rule_id);
    if(!!rule_id){
    setProps({searchInfo:{ruleId:rule_id}});
    // reload()
      }
    })

   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
       rule_id:rule_id,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     
     if(selectedRowKeys.value.length > 0){
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
     }else{
       createMessage.warning('请选择待删除规则!');
        return;
     }
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }

   /**
    * 设置评估要素
    */
  function handleSetIndi(record: Recordable) {
    closeCurrent();
    router.push({path: '/rate/rateKeyitemList',query:{id:record.id}})
    
   
   }

   function toPage() {
    closeCurrent();
    router.push({path: '/rate/rateRuleList'})
    
   
   }




   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
        {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         },
         {
           label: '|',
           
         },
         {
           label: '修改',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '|',
           
         },
         {
           label: '评估要素',
           onClick: handleSetIndi.bind(null, record),
         }
         
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [ /**
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         } */
       ]
   }


    function batchHandCopy() {
     
     if(selectedRowKeys.value.length > 0){
    // await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
    openModalCopy(true, {
       isUpdate: true,
       showFooter: true,
       domain_ids:selectedRowKeys.value,
     });

     }else{
       createMessage.warning('请选择待复制领域!');
        return;
     }
   }


</script>

<style scoped>

</style>